
/*
 Copyright (C) 2000, 2001, 2002 RiskMap srl

 This file is part of QuantLib, a free-software/open-source library
 for financial quantitative analysts and developers - http://quantlib.org/

 QuantLib is free software: you can redistribute it and/or modify it under the
 terms of the QuantLib license.  You should have received a copy of the
 license along with this program; if not, please email ferdinando@ametrano.net
 The license is also available online at http://quantlib.org/html/license.html

 This program is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 FOR A PARTICULAR PURPOSE.  See the license for more details.
*/

// $Id: MontecarloTools.i,v 1.13 2002/01/16 14:50:51 nando Exp $

#ifndef quantlib_montecarlo_tools_i
#define quantlib_montecarlo_tools_i

%include QLArray.i
%include Vectors.i

%{
using QuantLib::MonteCarlo::GaussianMultiPathGenerator;
using QuantLib::MonteCarlo::getCovariance;
%}

/*
class GaussianArrayGenerator {
  public:
	GaussianArrayGenerator(const Array& average,
        const Matrix& covariance, long seed=0);
    ~GaussianArrayGenerator();
	Array next() const;
	double weight() const;
};

class GaussianMultiPathGenerator {
  public:
	GaussianMultiPathGenerator(const DoubleVector& timeDelays,
        const Matrix& covariance, const Array& average, long seed=0);
    ~GaussianMultiPathGenerator();
	MultiPath next() const;
	double weight() const;
};

*/

Matrix getCovariance(const Array &volatilities, const Matrix &correlations);


#endif
